;  Title    :  Stock Quote Downloader
;  Author   :  peacekpr
;  Functions:  a useful utility to download and monitor the progress
;              of up to 10 stock quotes/mutual funds at one time.
;  Commands :  /stock (or Shift+F8); everything else is self-explanatory
;              and user-friendly!
;  Versions :  recommended to use with mIRC v5.6+
;  Comments :  Thanks for downloading :)  Enjoy.


on 1:load:{
  echo -s * Loading Stock Quote Downloader...
  unset %stk*
  echo -s * `--> Allocated needed space.
  echo -s * `--> Checking script integrity...
  if ($exists($scriptdirdown.bmp) == $false) { echo -s * `---> Error: could not find down.bmp in script's directory! | echo -s * `--> Load Failure: extract all necessary files to the same directory! | unload -rs $script | set %stkloading err | halt }
  if ($exists($scriptdirup.bmp) == $false) { echo -s * `---> Error: could not find up.bmp in script's directory! | echo -s * `--> Load Failure: extract all necessary files to the same directory! | unload -rs $script | set %stkloading err | halt }
  echo -s * `--> Verified & Ready to Use!
}
on 1:start:{
  if (%stkloading == err) { unset %stkloading | halt }
  set %stk.dir1 $scriptdirup.bmp
  set %stk.dir2 $scriptdirdown.bmp
  echo -s * Stock Quote Downloader initialized! - Hit Shift+F8 to run!
}
alias sf8 { dialog -dmvar setstock setstock }
alias stock { dialog -dmvar setstock setstock }
dialog setstock {
  title "Set Stock Quotes"
  size 0 0 260 168

  button "&Cancel", 1, 3 145 256 20, default cancel
  button "&Look Up", 2, 3 65 256 20

  box "Enter no more than 10 Stock Quotes to Lookup:", 4, 3 3 256 60

  edit "", 5, 5 20 50 20
  edit "", 6, 55 20 50 20
  edit "", 7, 105 20 50 20
  edit "", 8, 155 20 50 20
  edit "", 9, 205 20 50 20

  edit "", 10, 5 40 50 20
  edit "", 11, 55 40 50 20
  edit "", 12, 105 40 50 20
  edit "", 13, 155 40 50 20
  edit "", 14, 205 40 50 20

  text "Q: But I can't remember the symbol, but I do know the", 15, 3 85 394 15
  text "     company's name! How do I find the symbol for it?", 16, 3 97 394 15

  text "A: Easy! Just               for it! (click the [&search] button)", 17, 3 120 394 15
  button "&search", 18, 68 119 38 16
}
on 1:dialog:setstock:init:0:{
  did -ef setstock 5

  set %stk.x 4
  :loop
  inc %stk.x
  if (%stk.x <= 14) {
    if (%stk [ $+ [ %stk.x ] ] != $null) { did -ra setstock %stk.x %stk [ $+ [ %stk.x ] ] | goto loop }
    else { goto loop }
  }
  else { return }
}
on 1:dialog:setstock:sclick:2:{
  stkcheckspaces
}
alias stkcheckspaces {
  if ($dialog(setstock) == $null) { dialog -dmvar setstock setstock }
  set %stk.i 4
  unset %stklookup
  :loop
  inc %stk.i
  if (%stk.i <= 14) {
    if ($did(setstock,%stk.i).text == $null) { unset %stk [ $+ [ %stk.i ] ] | goto loop }
    else { set %stklookup %stklookup $+ &symbol= $+ $did(setstock,%stk.i).text $+ &selected= | set %stk [ $+ [ %stk.i ] ] $did(setstock,%stk.i).text | goto loop }
  }
  else {
    if (%stklookup != $null) {
      set %stklookup /Quote.dll?mode=stock&page=quick $+ %stklookup
      sockopen nasdaq quotes.nasdaq-amex.com 80
    }
  }
}
on 1:dialog:setstock:sclick:18:{
  dialog -dmv findstock findstock
}
on 1:sockclose:nasdaq:{
  did -ra stock 3 Updating quotes...
  stk.visible
  stk.hide %stk.quote
  did -ra stock 3 Done updating quotes!
  set %stk.refresh2 1
  .timer -o 1 5 stk.refresh
}
on 1:sockopen:nasdaq:{
  .timerrefresh off
  if ($dialog(stock) != $null) { did -ra stock 3 Downloading new quotes... }
  if ($sockerr > 0) { echo -a *** Error downloading from NasDaq! | halt }
  set %stk.quote 0
  set %stk.status 0
  sockwrite -n nasdaq GET %stklookup
  if ($dialog(stock) == $null) { .timer -om 1 1 dialog -dmv stock stock }
  else { .timer -om 1 1 dialog -v stock }
}
on 1:sockread:nasdaq:{
  sockread %nasdaq.tmp
  set %nasdaq.tmp $remove(%nasdaq.tmp,$chr(9))
  if ($left(%nasdaq.tmp,147) == <td nowrap align=left><font face="Arial,Helvetica,Verdana" size=2><b><a href="http://quotes.nasdaq-amex.com/quote.dll?page=multi&mode=stock&symbol=) { inc %stk.status | inc %stk.quote | did -ra stock 3 Downloading new quotes...( [ $+ [ %stk.quote ] $+ ] ) | did -ra stock [ [ %stk.quote ] $+ ] 0 $gettok($gettok(%nasdaq.tmp,5,62),1,60) | return }
  elseif (%stk.status == 1) { inc %stk.status | did -ra stock [ [ %stk.quote ] $+ ] 1 $gettok($gettok(%nasdaq.tmp,3,62),1,60) | return }
  elseif (%stk.status == 2) { inc %stk.status | did -ra stock [ [ %stk.quote ] $+ ] 2 $gettok($gettok(%nasdaq.tmp,5,62),1,60) | return }
  elseif (%stk.status == 3) {
    inc %stk.status
    if ($gettok($gettok(%nasdaq.tmp,6,62),1,60) == unch) { did -ra stock [ [ %stk.quote ] $+ ] 3 unchanged }
    else { did -ra stock [ [ %stk.quote ] $+ ] 3 $gettok($gettok(%nasdaq.tmp,6,62),1,60) }
    if ($gettok($gettok(%nasdaq.tmp,7,62),2,34) == http://www.nasdaq.com/images/nc_up.gif) { did -v stock [ [ %stk.quote ] $+ ] 6 | did -h stock [ [ %stk.quote ] $+ ] 7 | return }
    elseif ($gettok($gettok(%nasdaq.tmp,7,62),2,34) == http://www.nasdaq.com/images/nc_down.gif) { did -h stock [ [ %stk.quote ] $+ ] 6 | did -v stock [ [ %stk.quote ] $+ ] 7 | return }
    return
  }
  elseif (%stk.status == 4) { inc %stk.status | did -ra stock [ [ %stk.quote ] $+ ] 4 $gettok($gettok(%nasdaq.tmp,6,62),1,60) | return }
  elseif (%stk.status == 5) { unset %stk.status | did -ra stock [ [ %stk.quote ] $+ ] 5 $gettok($gettok(%nasdaq.tmp,3,62),1,60) | return }
  return
}
dialog findstock {
  title "Search for a Symbol"
  size 0 0 230 118

  button "&Cancel", 1, 115 95 112 20, cancel
  button "&Search", 4, 3 95 112 20, default

  text "Enter a Company Name to Search for:", 2, 3 3 224 17, center
  text "Select the Options You Would Like.", 5, 3 18 224 17, center
  edit "", 3, 3 73 224 20

  check "Stocks", 6, 33 33 60 18
  check "Mutual Funds", 7, 115 33 85 18

  text "or", 8, 95 35 20 18

  check "Starting With", 9, 33 53 85 18
  check "Contains", 10, 138 53 85 18

  text "or", 11, 119 55 20 18

  edit "Status: idle", 12, 3 277 224 20, read
  text "Company Name:", 13, 3 117 100 17
  text "Symbol:", 14, 160 117 100 17

  list 15, 3 136 140 140, read vsbar
  list 16, 155 136 71 140, read vsbar

  text "", 17, 3 262 224 16, center
}
on 1:dialog:findstock:init:0:{
  did -f findstock 3
  did -c findstock 6
  did -c findstock 9
  set %mkt ILX
  set %contain 0
  set %srch name
}
on 1:dialog:findstock:sclick:4:{
  if ($did(findstock,3).text == $null) { .timer -om 1 1 stkalert findstock Enter a Search String, please! }
  else {
    dialog -s findstock 0 0 230 300
    set %key $did(findstock,3).text
    set %key $remove(%key,$chr(44))
    set %key $replace(%key,$chr(32),+)
    did -ra findstock 12 Status: connecting to www.nasdaq.com...
    sockclose nasdaqsrch
    sockopen nasdaqsrch www.nasdaq.com 80
  }
}
on 1:dialog:findstock:sclick:15:{
  did -c findstock 16 $did(findstock,15).sel
  did -ra findstock 17 $did(findstock,15,$did(findstock,15).sel).text
}
on 1:dialog:findstock:dclick:15:{
  stkinsert $did(findstock,16,$did(findstock,15).sel).text
}
on 1:dialog:findstock:sclick:16:{
  did -c findstock 15 $did(findstock,16).sel
  did -ra findstock 17 $did(findstock,15,$did(findstock,15).sel).text
}
on 1:dialog:findstock:dclick:16:{
  stkinsert $did(findstock,16,$did(findstock,16).sel).text
}
on 1:dialog:findstock:sclick:6:{
  if ($did(findstock,7).state == 1) { did -u findstock 7 | set %mkt ILX }
  elseif ($did(findstock,6).state == 0) { did -c findstock 7 | set %mkt mmf }
}
on 1:dialog:findstock:sclick:7:{
  if ($did(findstock,6).state == 1) { did -u findstock 6 | set %mkt mmf }
  elseif ($did(findstock,7).state == 0) { did -c findstock 6 | set %mkt ILX }
}
on 1:dialog:findstock:sclick:9:{
  if ($did(findstock,10).state == 1) { did -u findstock 10 | set %contain 0 }
  elseif ($did(findstock,9).state == 0) { did -c findstock 10 | set %contain 1 }
}
on 1:dialog:findstock:sclick:10:{
  if ($did(findstock,9).state == 1) { did -u findstock 9 | set %contain 1 }
  elseif ($did(findstock,10).state == 0) { did -c findstock 9 | set %contain 0 }
}
alias stkalert {
  set %stkalert.dialog $1
  set %stkalert.msg $2-
  %stkalert = $dialog(stkalert,stkalert)
}
dialog stkalert {
  size 150 150 250 75
  title "Stock - Error"

  button "OK", 1, 102 54 50 20, default ok
  edit "", 2, 3 3 244 50, read multi vsbar
}
on 1:dialog:stkalert:init:0:{
  did -ra stkalert 2 %stkalert.msg
}
on 1:dialog:stkalert:1:{
  dialog -v %stkalert.dialog %stkalert.dialog

}
on 1:sockopen:nasdaqsrch:{
  if ($sockerr > 0) { did -ra findstock 12 Status: connection error ( $+ $sockerr $+ ) - idle | halt }
  did -ra findstock 12 Status: requesting info...
  did -r findstock 15,16
  unset %stk.nomatch
  sockwrite -n nasdaqsrch GET /asp/comlookup.asp?srch=name $+ &contain= $+ %contain $+ &mkt= $+ %mkt $+ &key= $+ %key
}
on 1:sockread:nasdaqsrch:{
  did -ra findstock 12 Status: receiving data...hold
  .timerstkdata -om 1 100 did -r findstock 12
  sockread %nasdaqsrch.tmp
  set %nasdaqsrch.tmp $remove(%nasdaqsrch.tmp,$chr(9))
  if (%nasdaqsrch.tmp == <td>No match found. Please try again.</td>) { set %stk.nomatch yes }
  if ($left(%nasdaqsrch.tmp,50) == <td><font size="3" face="Arial,Helvetica,Verdana">) && (%company == $null) { did -a findstock 15 $gettok($gettok(%nasdaqsrch.tmp,3,62),1,60) | set %company set }
  if ($left(%nasdaqsrch.tmp,132) == <td><font size="3" face="Arial,Helvetica,Verdana"><a HREF="http://quotes.nasdaq-amex.com/Quote.dll?page=multi&mode=Stock&amp;symbol=) && (%company == set) { did -a findstock 16 $gettok($gettok(%nasdaqsrch.tmp,4,62),1,60) | unset %company }
  return
}
on 1:sockclose:nasdaqsrch:{
  if (%stk.nomatch == yes) { did -ra findstock 12 Status: done listing...no matches }
  else { did -ra findstock 12 Status: done listing... }
  .timerstkdata off
}
alias stkinsert {
  set %stk.y 4
  :loop
  inc %stk.y
  if (%stk.y <= 14) {
    if ($did(setstock,%stk.y).text == $null) { did -ra setstock %stk.y $1 | goto end }
    else { goto loop }
  }
  elseif (%stk.y > 14) { did -ra findstock 17 All boxes are full! Remove one, please! | goto end2 }
  :end
  did -ra findstock 17 Inserted Symbol ' $+ $1 $+ ' to box $calc(%stk.y - 4)
  :end2
}
dialog stock {
  title "Requested Stock Quotes and Info"
  size 50 50 381 260

  button "&Close", 1, 78 3 75 20, default ok
  button "&Refresh", 2, 3 3 75 20

  edit "", 3, 155 3 223 20, read

  text "Symbol", 4, 3 23 50 17
  text "Market", 5, 56 23 50 17
  text "Last Sale", 6, 109 23 50 17
  text "Net Change", 7, 171 23 60 17
  text "% Change", 8, 243 23 50 17
  text "Volume", 9, 308 23 50 17
  ;Market Last Sale     ][     Net Change    ][     % Change    ][     Volume    ]", 4, 3 23 600 18

  ;#1
  edit "", 10, 3 46 53 20, center read autohs
  edit "", 11, 56 46 53 20, center read autohs
  edit "", 12, 109 46 62 20, center read autohs
  edit "", 13, 171 46 60 20, center read autohs
  edit "", 14, 243 46 64 20, center read autohs
  edit "", 15, 308 46 70 20, center read autohs

  icon 16, 231 52 11 11, %stk.dir1
  icon 17, 231 52 11 11, %stk.dir2

  ;#2
  edit "", 20, 3 66 53 20, center read autohs
  edit "", 21, 56 66 53 20, center read autohs
  edit "", 22, 109 66 62 20, center read autohs
  edit "", 23, 171 66 60 20, center read autohs
  edit "", 24, 243 66 64 20, center read autohs
  edit "", 25, 308 66 70 20, center read autohs

  icon 26, 231 72 11 11, %stk.dir1
  icon 27, 231 72 11 11, %stk.dir2

  ;#3
  edit "", 30, 3 86 53 20, center read autohs
  edit "", 31, 56 86 53 20, center read autohs
  edit "", 32, 109 86 62 20, center read autohs
  edit "", 33, 171 86 60 20, center read autohs
  edit "", 34, 243 86 64 20, center read autohs
  edit "", 35, 308 86 70 20, center read autohs

  icon 36, 231 92 11 11, %stk.dir1
  icon 37, 231 92 11 11, %stk.dir2

  ;#4
  edit "", 40, 3 106 53 20, center read autohs
  edit "", 41, 56 106 53 20, center read autohs
  edit "", 42, 109 106 62 20, center read autohs
  edit "", 43, 171 106 60 20, center read autohs
  edit "", 44, 243 106 64 20, center read autohs
  edit "", 45, 308 106 70 20, center read autohs

  icon 46, 231 112 11 11, %stk.dir1
  icon 47, 231 112 11 11, %stk.dir2

  ;#5
  edit "", 50, 3 126 53 20, center read autohs
  edit "", 51, 56 126 53 20, center read autohs
  edit "", 52, 109 126 62 20, center read autohs
  edit "", 53, 171 126 60 20, center read autohs
  edit "", 54, 243 126 64 20, center read autohs
  edit "", 55, 308 126 70 20, center read autohs

  icon 56, 231 132 11 11, %stk.dir1
  icon 57, 231 132 11 11, %stk.dir2

  ;#6
  edit "", 60, 3 146 53 20, center read autohs
  edit "", 61, 56 146 53 20, center read autohs
  edit "", 62, 109 146 62 20, center read autohs
  edit "", 63, 171 146 60 20, center read autohs
  edit "", 64, 243 146 64 20, center read autohs
  edit "", 65, 308 146 70 20, center read autohs

  icon 66, 231 152 11 11, %stk.dir1
  icon 67, 231 152 11 11, %stk.dir2

  ;#7
  edit "", 70, 3 166 53 20, center read autohs
  edit "", 71, 56 166 53 20, center read autohs
  edit "", 72, 109 166 62 20, center read autohs
  edit "", 73, 171 166 60 20, center read autohs
  edit "", 74, 243 166 64 20, center read autohs
  edit "", 75, 308 166 70 20, center read autohs

  icon 76, 231 172 11 11, %stk.dir1
  icon 77, 231 172 11 11, %stk.dir2

  ;#8
  edit "", 80, 3 186 53 20, center read autohs
  edit "", 81, 56 186 53 20, center read autohs
  edit "", 82, 109 186 62 20, center read autohs
  edit "", 83, 171 186 60 20, center read autohs
  edit "", 84, 243 186 64 20, center read autohs
  edit "", 85, 308 186 70 20, center read autohs

  icon 86, 231 192 11 11, %stk.dir1
  icon 87, 231 192 11 11, %stk.dir2

  ;#9
  edit "", 90, 3 206 53 20, center read autohs
  edit "", 91, 56 206 53 20, center read autohs
  edit "", 92, 109 206 62 20, center read autohs
  edit "", 93, 171 206 60 20, center read autohs
  edit "", 94, 243 206 64 20, center read autohs
  edit "", 95, 308 206 70 20, center read autohs

  icon 96, 231 212 11 11, %stk.dir1
  icon 97, 231 212 11 11, %stk.dir2

  ;#10
  edit "", 100, 3 226 53 20, center read autohs
  edit "", 101, 56 226 53 20, center read autohs
  edit "", 102, 109 226 62 20, center read autohs
  edit "", 103, 171 226 60 20, center read autohs
  edit "", 104, 243 226 64 20, center read autohs
  edit "", 105, 308 226 70 20, center read autohs

  icon 106, 231 232 11 11, %stk.dir1
  icon 107, 231 232 11 11, %stk.dir2
}
on 1:dialog:stock:init:0:{
  did -ra stock 3 Downloading new quotes...
}
on 1:dialog:stock:sclick:2:{
  stkcheckspaces
}
on 1:dialog:stock:sclick:1:{
  .timerrefresh off
}
alias stk.hide {
  set %stk.quote2 %stk.quote
  :loop
  inc %stk.quote
  if (%stk.quote <= 10) {
    did -h stock [ [ %stk.quote ] $+ ] 0
    did -h stock [ [ %stk.quote ] $+ ] 1
    did -h stock [ [ %stk.quote ] $+ ] 2
    did -h stock [ [ %stk.quote ] $+ ] 3
    did -h stock [ [ %stk.quote ] $+ ] 4
    did -h stock [ [ %stk.quote ] $+ ] 5
    did -h stock [ [ %stk.quote ] $+ ] 6
    did -h stock [ [ %stk.quote ] $+ ] 7
    goto loop
  }
  else {
    if (%stk.quote2 == 1) { .timer -om 1 1 dialog -s stock 50 50 381 70 }
    elseif (%stk.quote2 == 2) { .timer -om 1 1 dialog -s stock 50 50 381 90 }
    elseif (%stk.quote2 == 3) { .timer -om 1 1 dialog -s stock 50 50 381 110 }
    elseif (%stk.quote2 == 4) { .timer -om 1 1 dialog -s stock 50 50 381 130 }
    elseif (%stk.quote2 == 5) { .timer -om 1 1 dialog -s stock 50 50 381 150 }
    elseif (%stk.quote2 == 6) { .timer -om 1 1 dialog -s stock 50 50 381 170 }
    elseif (%stk.quote2 == 7) { .timer -om 1 1 dialog -s stock 50 50 381 190 }
    elseif (%stk.quote2 == 8) { .timer -om 1 1 dialog -s stock 50 50 381 210 }
    elseif (%stk.quote2 == 9) { .timer -om 1 1 dialog -s stock 50 50 381 230 }
    elseif (%stk.quote2 == 10) { .timer -om 1 1 dialog -s stock 50 50 381 250 }
    else { }
  }
}
alias stk.visible {
  set %stk.quote3 0
  :loop
  inc %stk.quote3
  if (%stk.quote3 <= 10) {
    did -v stock [ [ %stk.quote ] $+ ] 0
    did -v stock [ [ %stk.quote ] $+ ] 1
    did -v stock [ [ %stk.quote ] $+ ] 2
    did -v stock [ [ %stk.quote ] $+ ] 3
    did -v stock [ [ %stk.quote ] $+ ] 4
    did -v stock [ [ %stk.quote ] $+ ] 5
    did -v stock [ [ %stk.quote ] $+ ] 6
    did -v stock [ [ %stk.quote ] $+ ] 7
    goto loop
  }
}
alias stk.refresh {
  if (%stk.refresh2 == 1) {
    if (%stk.refresh == $null) { set %stk.refresh 1800 }
    did -ra stock 3 Refresh set to $replace($duration(%stk.refresh),yrs,y,yr,y,wks,w,wk,w,days,d,day,d,hrs,h,hr,h,mins,m,min,m,secs,s,sec,s)
    set %stk.refresh2 2
    .timerrefresh -o 0 1 stk.refresh
    set %stk.refresh3 %stk.refresh
  }
  else {
    if (%stk.refresh3 > 0) {
      did -ra stock 3 Will refresh in $replace($duration(%stk.refresh3),yrs,y,yr,y,wks,w,wk,w,days,d,day,d,hrs,h,hr,h,mins,m,min,m,secs,s,sec,s)
      dec %stk.refresh3
    }
    else {
      .timerrefresh off
      sockopen nasdaq quotes.nasdaq-amex.com 80
    }
  }
}
